function CanvasSlider(parent,width, min, max) {
    
    var me = this;
    
    this.width = width;
    this.min = min;
    this.max = max;
    this.parent = parent;
    this.height = 40;
    this.padding = 10;
    this.yPos = 35;
   
    // create canvas
    this.slider = document.createElement('canvas');
    this.slider.width = this.width;
    this.slider.style.width = this.width + 'px';
    this.slider.height = this.height;
    this.slider.style.height = this.height + 'px';
    this.slider.style.background = "blue";
    
    this.parent.appendChild(this.slider);
    
    this.ctx = this.slider.getContext('2d');
    
    this.drawSlider = function(drawDots) {
     
        this.ctx.clearRect(0,0,this.width, this.height);
        this.ctx.save();
        this.ctx.beginPath();
        this.ctx.moveTo(this.padding,this.yPos);
        console.log(this.width - (this.padding * 2));
        this.ctx.lineTo(this.width - this.padding,this.yPos);
        this.ctx.strokeStyle = "yellow";
        this.ctx.lineWidth = 2;
        this.ctx.stroke();
        this.ctx.restore();
        
        if (drawDots == true) {
         
            numDots = this.max - this.min - 1;
            var spacing = (this.width - (this.padding * 2)) / (numDots + 1);
            
            for (var i = 0; i < numDots; i++) {
                this.ctx.beginPath();
                this.ctx.arc(this.padding + spacing * (i + 1), this.yPos, 1, 0,2 * Math.PI);
                
            this.ctx.strokeStyle = 'black';
            this.ctx.stroke();
            }
            
            
        }
        
    }
    
    this.slider.onmouseover = function(event) {
        me.drawSlider(true);
    }
    
    this.slider.onmouseout = function(event) {
        me.drawSlider(false);
    }
    
    
}

var t = new CanvasSlider(document.getElementById('slider1'),250, 2, 9);
t.drawSlider();