var saveButton = document.getElementById('save');
var cancelButton = document.getElementById('cancel');
var restoreDefaults = document.getElementById('defaults');

var gridVisible = document.getElementById('gridVisible');
var gridOptionsVisible = document.getElementById('gridOptionsVisible');


// TODO get defaults from grid.js
var defaults = {
  "xPoints": "3",
  "yPoints": "3",
  "zPoints": "3",
  "zActive": 2,
  "gridButtonSize": "26",
  "ignoreMasks": true,
  "gridVisible": true,
  "gridOptionsVisible": true,
  "customMoveVisible": true,
  "matchVisible": true,
  "gridMode": "object",
  "matchType": true
}

var csInterface = new CSInterface();
 themeManager.init();


var prefFile = window.cep.fs.readFile( csInterface.getSystemPath(SystemPath.USER_DATA) + "/MoveAnchorPoint/prefs.txt"); 
// create pref file if it doesn't exist
var prefs;
if (prefFile.err == 0) {
    prefs = JSON.parse(prefFile.data);
} else {
 // prefs file doesn't exists (somehow...); 
    prefs = defaults;
    //TODO this is copied from grid.js, fix that
    var path = csInterface.getSystemPath(SystemPath.USER_DATA) + "/MoveAnchorPoint";
    var mapDir = window.cep.fs.readdir(path);
    var errors = 0;
    if (mapDir.err != 0) {
        // if not, create it
        result = window.cep.fs.makedir(path);
        errors = result.err;
    }
    if (errors == 0) {
        window.cep.fs.writeFile(path + "/prefs.txt", JSON.stringify(prefs,null,2));  
    }
}
loadPrefs(prefs);

function loadPrefs(prefs, callback) {
 
    for (var key in prefs) {
     
        var curProp = document.getElementById(key);
        if (curProp) {
            if (curProp.type == "checkbox") {
                curProp.checked = prefs[key];
            } else {
                curProp.value = prefs[key];
            }
        }
        
    }
    
    var sliderVals = document.getElementsByClassName('slider-amount');
    
    for (var i = 0; i < sliderVals.length; i++) {
        sliderVals[i].innerHTML = sliderVals[i].previousElementSibling.value;
        
    }
    
    if (callback) {
        callback();
    }
    
}

function savePrefs() {
    
    var allPrefs = document.getElementsByClassName('preference');
    for (var i = 0; i < allPrefs.length; i++) {
     
        curPref = allPrefs[i];
        if (curPref.type == "checkbox") {
            prefs[curPref.id] = curPref.checked;
        } else {
            prefs[curPref.id] = curPref.value;
        }
        
    }
    
    window.cep.fs.writeFile(csInterface.getSystemPath(SystemPath.USER_DATA) + "/MoveAnchorPoint/prefs.txt", JSON.stringify(prefs,null,2));
    
}

function updateSliderValue(slider) {
    
    slider.nextElementSibling.innerHTML = slider.value;
    var data = {"type": slider.id, "value": slider.value}
    createPrefEvent(data);
    
}

function updateVisibilityPref(section) {
    //if (section == gridVisible && section.checked == false) 
    //    gridOptionsVisible.checked = false;
    
    //if (section == gridOptionsVisible && section.checked == true)
    //    gridVisible.checked = true;
    

    var data = {
     "type": section.id,
     "value": section.checked
    }
    createPrefEvent(data);
}

function createPrefEvent(data) {
    var prefChange = new CSEvent("com.batchframe.cep.pref","APPLICATION");
    prefChange.data = data;
    csInterface.dispatchEvent(prefChange);
}

saveButton.onclick = function() {
 
    savePrefs();
    csInterface.closeExtension();
    
}

cancelButton.onclick = function() {
    var prefClose = new CSEvent("com.batchframe.cep.prefClose","APPLICATION");
    csInterface.dispatchEvent(prefClose);
    csInterface.closeExtension();
}

restoreDefaults.onclick = function() {
 
    loadPrefs(defaults, function() {
        var rd = new CSEvent("com.batchframe.cep.defaults","APPLICATION");
        rd.data = defaults;
        csInterface.dispatchEvent(rd);
    });
    
    
}


